# -*- coding: utf-8 -*-
"""dataset_utils

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1fj5uzHmhBhq2VwAzDBKnu8iJiGPXWRht
"""

import os
import cv2
from itertools import chain
import numpy as np
import pandas as pd
from keras.utils import np_utils

try:
    # use Sequence defined at environment
    a = Sequence.__doc__
except:
    from keras.utils import Sequence

try:
    a = BASE_PATH
except:
    BASE_PATH = 'kowalski/input/chest_xray/chest_xray'

try:
    a = G_PATH
except:
    G_PATH = '/gdrive/My Drive/INF-0619'

    
# classes
NORMAL=0
BACTERIA=1
VIRUS=2

def load_df(protocol, root_path=G_PATH):
    if protocol == 0 or protocol == 'original':
        df = pd.read_csv(os.path.join(root_path, 'protocol0.csv'))
    elif protocol == 1 or protocol == 'alternative':
        df = pd.read_csv(os.path.join(root_path, 'protocol_alternative.csv'))

    return df

def random_crop(img, resize=(112, 112)):
    w,h = img.shape[0], img.shape[1]
    l = min([w,h])
    dw, dh = (w-l), (h-l)
    dw1 = np.random.randint(dw) if dw > 0 else 0
    dh1 = np.random.randint(dh) if dh > 0 else 0
    dw2, dh2 = dw-dw1, dh-dh1

    crop =  img[dw1:w-dw2, dh1:h-dh2, :]
  
    return cv2.resize(crop, resize) 

def central_crop(img, resize=(112, 112)):
    w,h = img.shape[0], img.shape[1]
    l = min([w,h])
    dw, dh = (w-l), (h-l)
    dw1 = dw // 2
    dh1 = dh // 2
    dw2, dh2 = dw-dw1, dh-dh1

    crop =  img[dw1:w-dw2, dh1:h-dh2, :]

    return cv2.resize(crop, resize) 


def load_and_preprocess_rgb(path):
    img = cv2.imread(path)

    return img

def load_and_preprocess_gray3(path):
    img = cv2.imread(path)
    img = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)

    shape = list(img.shape) + [3]
    X = np.zeros(shape, dtype=np.float32)
    X[:, :, 0] = img
    X[:, :, 1] = img
    X[:, :, 2] = img

    return x

def resize_img(img, resize=(112, 112)):
    return cv2.resize(img, resize) 

def img_normalization(img):
    img = img.astype(np.float32)
    img /= 127.5
    img -= 1

    return img

def path_and_one_hot_class1_translation_fn(row, nb_classes=2, base_path=BASE_PATH):
    class_map = {'normal': 0, 'pneumonia': 1}
    return "%s/%s" % (base_path, row.Path), np_utils.to_categorical(class_map[row.Class1], num_classes=nb_classes)

def path_and_one_hot_class2_translation_fn(row, nb_classes=3, base_path=BASE_PATH):
    class_map = {'normal': 0, 'bacteria': 1, 'virus': 2}
    return "%s/%s" % (base_path, row.Path), np_utils.to_categorical(class_map[row.Class2], num_classes=nb_classes)

def load_and_preprocess_rgb_resize(path, resize=(112, 112)):
    img = cv2.imread(path)
    img = cv2.resize(img, resize) 

    if img.shape[2] ==1:
        img = np.dstack([img, img, img])
        img = cv2.cvtColor(img, cv2.COLOR_BGR2RGB)

        return img

def getDatasetSize(df, split='train', types=[NORMAL,BACTERIA,VIRUS], stratify='Class2', 
                    balanced=False, base_path=BASE_PATH):
    """
    Obtains the number from samples of each class (protocol 1 and 2).
    """
    if split not in ["train", "val", "test"]:
        raise ValueError(split + " not recognized. Did you mean 'train', 'val' or 'test'?")
    step = "%s  distribution" % split
    df = df[df.Set == split]
    
    #Get all file names for that split
    if not type(types) in (list, tuple):
        types = [types]
    
    indexes = {clazz: df[df[stratify] == clazz].index.tolist() for clazz in df[stratify].unique()}
    indexes = {k:l for k,l in indexes.items() if len(l) > 0}
    
    if balanced:
        lenght = min(map(len, indexes.values()))
    else:
        lenght = max(map(len, indexes.values()))

    indexes = {clazz: values[:lenght] for clazz, values in indexes.items()}
    
    n = sum([len(v) for v in indexes.values()])
    return n


def getDatasetFiles(df, split='train', types=[NORMAL,BACTERIA,VIRUS], stratify='Class2', 
                    balanced=False, shuffle=False, base_path=BASE_PATH):
    """
    Obtains the path from samples of each class of the dataset (protocol 2).
    """
    if split not in ["train", "val", "test"]:
        raise ValueError(split + " not recognized. Did you mean 'train', 'val' or 'test'?")
    step = "%s  distribution" % split
    #df = df[df.Set == step]
    
    #Get all file names for that split
    if not type(types) in (list, tuple):
        types = [types]
    
    indexes = {clazz: df[df[stratify] == clazz].index.tolist() for clazz in df[stratify].unique()}
    indexes = {k:l for k,l in indexes.items() if len(l) > 0}
    
    if balanced:
        lenght = min(map(len, indexes.values()))
    else:
        lenght = max(map(len, indexes.values()))

    if shuffle:
        indexes = {clazz: np.random.choice(values, size=lenght, replace=True) for clazz, values in indexes.items()}
    else:
        indexes = {clazz: values[:lenght] for clazz, values in indexes.items()}
    
    import glob
    fileNames = {}
    
    if NORMAL in types:
        fileNames[NORMAL] = ["%s/%s" % (base_path, df["Path"][df[df.index == row_idx].index[0]]) for row_idx in indexes["normal"]]
    if BACTERIA in types:        
        fileNames[BACTERIA] = ["%s/%s" % (base_path, df["Path"][df[df.index == row_idx].index[0]]) for row_idx in indexes["bacteria"]]
    if VIRUS in types:
        fileNames[VIRUS] = ["%s/%s" % (base_path, df["Path"][df[df.index == row_idx].index[0]]) for row_idx in indexes["virus"]]
        
    fileNames = {clazz: [v for v in values] for clazz, values in fileNames.items()}
    
    return fileNames


class DataLoader(Sequence):
    def __init__(self, df = None, batch_size=32, nb_classes=3, stratify=None,
                image_shape=(112, 112), dataAugmentator=None, shuffle=True, imagenet_norm=False,
                load_and_preprocess_fn=None, path_and_class_translation_fn=None):
        self.df = df
        self.image_shape = image_shape
        self.dataAugmentator = dataAugmentator
        self.shuffle = shuffle
        self.nb_classes = nb_classes
        self.imagenet_norm = imagenet_norm
        self.load_and_preprocess_fn = load_and_preprocess_fn
        self.path_and_class_translation_fn = path_and_class_translation_fn
        self.num_stratums = len(df[stratify].unique())
        self.partial_batch_size = batch_size // self.num_stratums

        indexes = {clazz: df[df[stratify] == clazz].index.tolist() for clazz in df[stratify].unique()}
        max_size = max(map(len, indexes.values()))
        self.size = max_size
        self.indexes = {clazz: np.random.choice(values, size=max_size, replace=True) for clazz, values in indexes.items()}
        if shuffle:
            self.indexes = {clazz: np.random.permutation(values) for clazz, values in self.indexes.items()}

    def __len__(self):
        return int(np.ceil(self.size / self.partial_batch_size))

    def __getitem__(self, index):
        # Generate indexes of the batch
        batch_indexes = []
        for key, stratum_indexes in self.indexes.items():
            batch_indexes.append(stratum_indexes[index*self.partial_batch_size:(index+1)*self.partial_batch_size])

            batch_indexes = list(chain.from_iterable(batch_indexes))
            np.random.shuffle(batch_indexes)
            batch_shape = tuple([len(batch_indexes)]+list(self.image_shape))

            batch_df = self.df.loc[batch_indexes]
            X = np.zeros(batch_shape, dtype=np.float32)
            Y = []

            for i, (index, row) in enumerate(batch_df.iterrows()):
                path, clazz = self.path_and_class_translation_fn(row)
                img = self.load_and_preprocess_fn(path)

                if self.dataAugmentator:
                    img = self.dataAugmentator(img)

                if self.imagenet_norm:
                    img = img_normalization(img)

                X[i, :, :, :] = img
                Y.append(clazz)

            X = np.array(X)
            y = np.vstack(Y)

            return (X, y)

    def on_epoch_end(self):
        if self.shuffle:
            self.indexes = {clazz: np.random.permutation(values) for clazz, values in self.indexes.items()}


